﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Net;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;
using System.IO;
using System.Collections;
using Infragistics.Windows.Chart;
using System.Web;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>

    public partial class Window1 : Window
    {
        public DataTable dtChainData = null;
        public Window1()
        {
            InitializeComponent();
        }

        private Int16 CalcStep(DataTable dtData)
        {
            Int16 iStep = 0;
            if (dtData != null && dtData.Rows.Count > 1)
                iStep = (Int16)(Convert.ToInt16(dtData.Rows[1]["STRIKE"]) - Convert.ToInt16(dtData.Rows[0]["STRIKE"]));
            else
                System.Windows.MessageBox.Show("Insufficient data to calculate step");
            return iStep;

        }

        public static DataTable ImportExcel(string sFileName, string sFilter, string sSheetName)
        {
            string sConnectionString = string.Empty;

            string sExtension = System.IO.Path.GetExtension(sFileName);

            sConnectionString = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source={0};Extended Properties=\"Excel 8.0\"";

            DataTable dataTable = null;
            using (OleDbConnection oleDbConnection = new OleDbConnection(string.Format(sConnectionString, sFileName)))
            {
                oleDbConnection.Open();
                //Getting the meta data information.         
                //This DataTable will return the details of Sheets in the Excel File.         
                DataTable dbSchema = oleDbConnection.GetOleDbSchemaTable(OleDbSchemaGuid.Tables_Info, null);
                if (dbSchema.Rows.Count > 0)
                {
                    string sSFilter = string.Format("TABLE_NAME = '{0}'", sSheetName + "$");
                    DataRow[] dr = dbSchema.Select(sSFilter);
                    if (!IsNull(dr) && dr.Length > 0)
                    {
                        //reading data from excel to Data Table             
                        using (OleDbCommand oleDbCommand = new OleDbCommand())
                        {
                            oleDbCommand.Connection = oleDbConnection;
                            oleDbCommand.CommandText = string.Format("SELECT * FROM [{0}{1}] order by STRIKE Asc", sSheetName, "$");

                            using (OleDbDataAdapter oleDbDataAdapter = new OleDbDataAdapter())
                            {
                                oleDbDataAdapter.SelectCommand = oleDbCommand;
                                dataTable = new DataTable();
                                oleDbDataAdapter.Fill(dataTable);
                            }
                            PurgeEmptyRows(ref dataTable);
                        }
                    }
                    else
                    {
                        throw new Exception("Excel must contain a sheet named " + sSheetName + ".");
                    }
                }

            }
            return dataTable;
        }

        public static void PurgeEmptyRows(ref DataTable dt)
        {
            DataTable dtRet = dt.Clone();
            foreach (DataRow dr in dt.Rows)
            {
                if (dr.RowState == DataRowState.Deleted)
                {
                    dtRet.ImportRow(dr);
                    continue;
                }

                ArrayList rowValues = new ArrayList();
                for (int i = 0; i < dt.Columns.Count; i++)
                {
                    rowValues.Add(dr[i]);
                }
                if (!ContainsAllEmpty(rowValues))
                    dtRet.ImportRow(dr);
            }

            dt = dtRet;
        }

        public static bool ContainsAllEmpty(ArrayList arr)
        {
            for (int i = 0; i < arr.Count; i++)
            {
                if (IsNull(arr[i]))
                    return false;
            }
            return true;
        }

        public static bool IsNull(object value)
        {
            bool isNull = false;
            //determines nullability using reflection
            //if input value is nothing return NULL value
            if (value == null)
            {
                isNull = true;
            }

            System.Type type = value.GetType();
            //bool isNullableType = IsNullableType(type);

            if (type == typeof(System.DBNull))
            {
                isNull = true;
            }
            else
                isNull = false;

            return isNull;
        }

        private void xamChart4_MouseDown(object sender, MouseButtonEventArgs e)
        {

            HitTestArgs test = xamChart4.HitTest(e);
            // Try to cast the SelectedObject to a DataPoint
            DataPoint dp = test.SelectedObject as DataPoint;

            //Check to see if the cast was successful
            if (dp != null)
            {
                //TODO: Code application logic here

            }
            //The MouseDown event is a bubbling event. If you do not set the e.Handled property to true, this event may fire more than once.
            e.Handled = true;

        }





        //private void ExportToExcel()
        //{

        //    System.Windows.Forms.WebBrowser wb = new System.Windows.Forms.WebBrowser();
        //    wb.DocumentCompleted -= new System.Windows.Forms.WebBrowserDocumentCompletedEventHandler(wb_DocumentCompleted);
        //    wb.DocumentCompleted += new System.Windows.Forms.WebBrowserDocumentCompletedEventHandler(wb_DocumentCompleted);
        //    wb.Navigate("http://www.nseindia.com/live_market/dynaContent/live_watch/option_chain/optionKeys.jsp?symbol=TATAMOTORS");




        //    //WebClient client = new WebClient();
        //    //            string html = client.DownloadString(@"http://localhost/AIWrapper/raw.html");
        //    //     string html = client.DownloadString(@"http://www.google.co.in/");
        //    //while (strInputHtml == null)
        //    //{

        //    //}





        //}

        //private void wb_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        //{
        //    System.Windows.Forms.WebBrowser Browser = sender as System.Windows.Forms.WebBrowser;
        //    strInputHtml = Browser.DocumentText;
        //    DataTable dt = HtmlTableParser.ParseTable(strInputHtml);
        //    DataTable dtfinal = HtmlTableParser.CreateFormattedTable(dt);
        //}

        public void InitializeWindow(string strSymbol)
        {
            try
            {
                this.Title = strSymbol.ToUpper();

                dtChainData.Columns.Add(HtmlTableParser.CPainValueColumnName, typeof(double));
                dtChainData.Columns.Add(HtmlTableParser.PPainValueColumnName, typeof(double));
                dtChainData.Columns.Add(HtmlTableParser.TotalPainValueColumnName, typeof(double));
                dtChainData.Columns.Add(HtmlTableParser.CallVsPutColumnName);
                dtChainData.Columns.Remove(HtmlTableParser.PAskPriceColumnName);
                dtChainData.Columns.Remove(HtmlTableParser.PAskQtyColumnName);
                dtChainData.Columns.Remove(HtmlTableParser.PBidPriceColumnName);
                dtChainData.Columns.Remove(HtmlTableParser.PBidQtyColumnName);
             
                dtChainData.Columns.Remove(HtmlTableParser.PVolumeColumnName);

                dtChainData.Columns.Remove(HtmlTableParser.CAskPriceColumnName);
                dtChainData.Columns.Remove(HtmlTableParser.CAskQtyColumnName);
                dtChainData.Columns.Remove(HtmlTableParser.CBidPriceColumnName);
                dtChainData.Columns.Remove(HtmlTableParser.CBidQtyColumnName);
              
                dtChainData.Columns.Remove(HtmlTableParser.CVolumeColumnName);

                if (dtChainData != null && dtChainData.Rows.Count > 0)
                {


                    for (int iCnt = 0; iCnt < dtChainData.Rows.Count; iCnt++)
                    {
                        double iCloseSP = Convert.ToInt16(dtChainData.Rows[iCnt][HtmlTableParser.Strike]);
                        double iCallValue = 0;
                        for (int i = iCnt; i > -1; i--)
                        {
                            Int16 iCurrentSP = Convert.ToInt16(dtChainData.Rows[i][HtmlTableParser.Strike]);
                            UInt64 iCOI = Convert.ToUInt64(dtChainData.Rows[i][HtmlTableParser.COIColumnName]);
                            iCallValue += (double)((double)(iCloseSP - iCurrentSP) * iCOI);

                        }


                        dtChainData.Rows[iCnt][HtmlTableParser.CPainValueColumnName] = iCallValue / 100000;



                        double iPutValue = 0;
                        for (int i = iCnt; i < dtChainData.Rows.Count; i++)
                        {
                            double iCurrentSP = Convert.ToInt16(dtChainData.Rows[i][HtmlTableParser.Strike]);
                            double iPOI = Convert.ToUInt64(dtChainData.Rows[i][HtmlTableParser.POIColumnName]);
                            iPutValue += (double)((double)(iCurrentSP - iCloseSP) * iPOI);

                        }


                        dtChainData.Rows[iCnt][HtmlTableParser.PPainValueColumnName] = iPutValue / 100000;

                        dtChainData.Rows[iCnt][HtmlTableParser.TotalPainValueColumnName] = (iPutValue + iCallValue) / 100000;
                        if (iPutValue > iCallValue)
                            dtChainData.Rows[iCnt][HtmlTableParser.CallVsPutColumnName] = "P";
                        else
                            dtChainData.Rows[iCnt][HtmlTableParser.CallVsPutColumnName] = "C";
                    }
                }

                
                Series oSeries1 = new Series();
                oSeries1.DataSource = dtChainData;
                oSeries1.DataMapping = "Value =" + HtmlTableParser.PPainValueColumnName + ";Label=" + HtmlTableParser.Strike + ";";
                Marker m = new Marker();
                m.Type = MarkerType.Circle;
                oSeries1.Marker = m;


                oSeries1.Label = "PUT";
                oSeries1.ChartType = ChartType.StackedColumn;
                xamChart1.Series.Add(oSeries1);
                Series oSeries2 = new Series();
                oSeries2.DataSource = dtChainData;
                oSeries2.DataMapping = "Value =" + HtmlTableParser.CPainValueColumnName + ";Label=" + HtmlTableParser.Strike + ";";
                // oSeries2.DataMapping = "CALL VALUE";
                oSeries2.Label = "CALL";
                Marker m1 = new Marker();
                m1.Type = MarkerType.Rectangle;
                oSeries2.Marker = m1;
                oSeries2.ChartType = ChartType.StackedColumn;
                xamChart1.Series.Add(oSeries2);
                xamChart1.DataContext = dtChainData;
                TChain.DataSource = dtChainData.DefaultView;

                Series oSeries11 = new Series();
                oSeries11.DataSource = dtChainData;
                oSeries11.DataMapping = "Value =" + HtmlTableParser.PChngInOIColumnName + ";Label=" + HtmlTableParser.Strike + ";";
                Marker mchgOIP = new Marker();
                mchgOIP.Type = MarkerType.Circle;
                oSeries11.Marker = mchgOIP;


                oSeries11.Label = "ChgOIPUT";
                oSeries11.ChartType = ChartType.Column;
                xamChart2.Series.Add(oSeries11);


                Series oSeries12 = new Series();
                oSeries12.DataSource = dtChainData;
                oSeries12.DataMapping = "Value =" + HtmlTableParser.CChngInOIColumnName + ";Label=" + HtmlTableParser.Strike + ";";
                Marker mchgOIC = new Marker();
                mchgOIC.Type = MarkerType.Rectangle;
                oSeries12.Marker = mchgOIC;


                oSeries12.Label = "ChgOICALL";
                oSeries12.ChartType = ChartType.Column;
                xamChart2.Series.Add(oSeries12);

                Series oSeries123 = new Series();
                oSeries123.DataSource = dtChainData;
                oSeries123.DataMapping = "Value =" + HtmlTableParser.PNetChngColumnName + ";Label=" + HtmlTableParser.Strike + ";";
                Marker mchgPricP = new Marker();
                mchgPricP.Type = MarkerType.Circle;
                oSeries123.Marker = mchgPricP;


                oSeries123.Label = "ChgPricePut";
                oSeries123.ChartType = ChartType.Column;
                xamChart4.Series.Add(oSeries123);



                Series oSeries1234 = new Series();
                oSeries1234.DataSource = dtChainData;
                oSeries1234.DataMapping = "Value =" + HtmlTableParser.CNetChngColumnName + ";Label=" + HtmlTableParser.Strike + ";";
                Marker mchgPricC = new Marker();
                mchgPricP.Type = MarkerType.Rectangle;
                oSeries1234.Marker = mchgPricC;


                oSeries1234.Label = "ChgPriceCall";
                oSeries1234.ChartType = ChartType.Column;
                xamChart4.Series.Add(oSeries1234);

                Series oSeries111 = new Series();
                oSeries111.DataSource = dtChainData;
                oSeries111.DataMapping = "Value =" + HtmlTableParser.POIColumnName + ";Label=" + HtmlTableParser.Strike + ";";
                Marker mOIP = new Marker();
                mOIP.Type = MarkerType.Circle;
                oSeries111.Marker = mOIP;


                oSeries111.Label = "OIP";
                oSeries111.ChartType = ChartType.Column;
                xamChart3.Series.Add(oSeries111);


                Series oSeries122 = new Series();
                oSeries122.DataSource = dtChainData;
                oSeries122.DataMapping = "Value =" + HtmlTableParser.COIColumnName + ";Label=" + HtmlTableParser.Strike + ";";
                Marker mOIC = new Marker();
                mOIC.Type = MarkerType.Rectangle;
                oSeries122.Marker = mOIC;


                oSeries122.Label = "OIC";
                oSeries122.ChartType = ChartType.Column;
                xamChart3.Series.Add(oSeries122);
            }
            catch (Exception ex)
            {
               System.Windows.MessageBox.Show(ex.Message);
            }
        }
        

      


         
         
    }
}
